<?php

class exampleTest extends PHPUnit_Framework_TestCase
{
    public function testStub()
    {
        // Create, receive and assigne mocked class
        $caller = new exampleCaller();
        $listener = $this->getMock( 'exampleListener', array(
            'call',
            'update',
        ) );
        $caller->setListener( $listener );

        // Set up stubs
        $listener
            ->expects( $this->any() )
            ->method( 'call' )
            ->will( $this->return( true ) );

        $listener
            ->expects( $this->any() )
            ->method( 'update' )
            ->will( $this->return( false ) );

        // Run tested classes, using the stubs
        $caller->run();
    }

    public function testSpy()
    {
        // Create, receive and assigne mocked class
        $caller = new exampleCaller();
        $listener = $this->getMock( 'exampleListener', array(
            'call',
        ) );
        $caller->setListener( $listener );

        // Set up expectations
        $listener
            ->expects( $this->once() )
            ->method( 'call' )
            ->with(
                $this->equalTo( 'signal'  ),
                $this->equalTo( array( 1, 2, 3 ) )
            );

        // Run tested classes, to match expectations
        $caller->run();
    }

    public function testMock()
    {
        // Create, receive and assigne mocked class
        $caller = new exampleCaller();
        $listener = $this->getMock( 'exampleListener', array(
            'call',
            'update',
        ) );
        $caller->setListener( $listener );

        // Set up expectations and return values
        $listener
            ->expects( $this->at( 0 ) )
            ->method( 'call' )
            ->with(
                $this->equalTo( 'signal'  ),
                $this->equalTo( array( 1, 2, 3 ) )
            )
            ->will( $this->return( true ) );

        $listener
            ->expects( $this->at( 1 ) )
            ->method( 'update' )
            ->will( $this->return( false ) );

        // Run tested classes
        $caller->run();
    }
}

